<?php

namespace App\Wrangler\Components;

use Illuminate\Http\Request;
use Medialight\Textstem\Models\WranglerPage;
use Medialight\Textstem\Wrangler\ActiveComponent;

/**
 * Class Sample
 *
 * A short summary of what this component does.
 *
 * @extends ActiveComponent
 */
class ContainerStart extends ActiveComponent
{
    public static string $description = 'Create a new container. It must be followed by a ContainerEnd component.';
    public static string $version = '1.0.0';

    public $config;

    public array $editSetup = [
        [
            'name' => 'template',
            'controltype' => 'select-template',
            'value' => 'default',
        ],
        [
            'name' => 'outer_class',
            'controltype' => 'select',
            'value' => '',
            'options' => [
                '' => 'Default',
                'bg-blue-200' => 'Blue background',
                'bg-green-200' => 'Green background',
                'bg-gray-200' => 'Gray background',
                'bg-primary' => 'Primary background',
                'bg-secondary' => 'Secondary background',
            ],
            'label' => 'Background Style',
        ],
        [
            'name' => 'inner_class',
            'controltype' => 'select',
            'value' => '',
            'options' => [
                'mx-auto max-w-7xl  lg:flex' => 'Contained row',
                'mx-auto max-w-7xl  lg:flex lg:flex-col' => 'Contained column',
                'lg:flex' => 'Full width',
                'lg:flex lg:flex-col' => 'Full width column',
            ],
            'label' => 'Inner Style',
        ],
        [
            'name' => 'grid_cols',
            'controltype' => 'select',
            'value' => '',
            'options' => [
                'grid-cols-1' => '1',
                'grid-cols-1 sm:grid-cols-2' => '2',
                'grid-cols-1 sm:grid-cols-2 md:grid-cols-3' => '3',
                'grid-cols-1 sm:grid-cols-3 md:grid-cols-4' => '4',
            ],
            'label' => 'Max Columns',
        ],
        [
            'name' => 'img',
            'controltype' => 'image',
            'value' => '',
            'label' => 'Background Image',
        ],
    ];

    public function render(Request $request, WranglerPage $wranglerPage)
    {
        $view = $this->getView();
        $data = $this->data();
        // add any extra stuff the view needs to $data
        return view($view, $data)->render();
    }

    public function preview()
    {
        $view = $this->getPreview();
        $data = $this->data();
        return view($view, $data)->render();
    }
}
